zsh-workers
 help / color / mirror / code / Atom feed
From: Martijn Dekker <martijn@inlv.org>
To: Zsh hackers list <zsh-workers@zsh.org>
Subject: [Bug] Exiting shell from function called by trap handler always produces status 0
Date: Mon, 8 Oct 2018 14:02:23 +0100	[thread overview]
Message-ID: <a5934536-7982-c434-d98d-2c07d66b0739@inlv.org> (raw)

When a trap handler exits the shell using the 'exit' command within a 
function, the shell's exit status is zero even if another exit status 
was given as an argument to the 'exit' command.

$ Src/zsh -c 'fn() { exit 13; }; trap "fn" EXIT'
$ echo $?
0
(expected output: 13)

I was able to reproduce this in zsh 5.4.1 and up, and not in 5.3.1 and 
earlier. Every other shell also exits with status 13.

Looping through git commits starting from zsh-5.3.1, I found the commit 
that introduced this: d7110d8 (41012: Fix premature exit from nested 
function in EXIT trap).

Thanks,

- M.

             reply	other threads:[~2018-10-09  1:26 UTC|newest]

Thread overview: 11+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
     [not found] <CGME20181009012624epcas1p44f2ae223f663713a980af4be735e5a3f@epcas1p4.samsung.com>
2018-10-08 13:02 ` Martijn Dekker [this message]
2018-10-09  8:49   ` Peter Stephenson
2018-10-09  9:58     ` Mikael Magnusson
2018-10-09 11:46     ` Martijn Dekker
2018-10-09 13:16       ` Peter Stephenson
2018-10-09 13:39         ` Daniel Shahaf
2018-10-09 13:43           ` Peter Stephenson
     [not found]           ` <1539092591.3286.12.camel@samsung.com>
2018-10-09 13:50             ` Peter Stephenson
2018-10-09 20:09         ` Peter Stephenson
2018-10-10  8:56           ` Daniel Shahaf
2018-10-10  9:31             ` Peter Stephenson

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=a5934536-7982-c434-d98d-2c07d66b0739@inlv.org \
    --to=martijn@inlv.org \
    --cc=zsh-workers@zsh.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://git.vuxu.org/mirror/zsh/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).